OSMIUM-MERGE-CHANGES(1)

NAME
osmium-merge-changes - merge several OSM change files into one

SYNOPSIS
osmium merge-changes [OPTIONS] OSM-CHANGE-FILE...

DESCRIPTION
Merges the content of all change files given on the command line into one large change file.

Objects are sorted by type, ID, version, and timestamp so it doesn’t matter in what order the change files are given or in what order they contain the data. (If you are using change files of extracts this is not necessarily true and you must specify the change files on the command line in the correct order from oldest to newest. This is because change files from extracts can contain multiple different object versions with the same version and timestamp!)

This command can only be used to merge change files from different points in time for the planet or for the same extract. It can not be used to merge changes from different, possibly overlapping extracts into one larger change for the whole area of all extracts, because it will not produce the correct result in all cases. This is not a limit of this command, but is due to the limited information available in change files.

This commands reads its input file(s) only once and writes its output file in one go so it can be streamed, ie. it can read from STDIN and write to STDOUT.

OPTIONS

-s, --simplify
    Only write the last version of any object to the output. For an object created in one of the change files and removed in a later one, the deleted version of the object will still appear because it is the latest version.

COMMON OPTIONS

-h, --help
    Show usage help.

-v, --verbose
    Set verbose mode. The program will output information about what it is doing to STDERR.

--progress
    Show progress bar. Usually a progress bar is only displayed if STDOUT and STDERR are detected to be TTY. With this option a progress bar is always shown. Note that a progress bar will never be shown when reading from STDIN or a pipe.

--no-progress
    Do not show progress bar. Usually a progress bar is displayed if STDOUT and STDERR are detected to be a TTY. With this option the progress bar is suppressed. Note that a progress bar will never be shown when reading from STDIN or a pipe.

INPUT OPTIONS

-F, --input-format=FORMAT
    The format of the input file(s). Can be used to set the input format if it can’t be autodetected from the file name(s). This will set the format for all input files, there is no way to set the format for some input files only. See osmium-file-formats(5) or the libosmium manual for details.

OUTPUT OPTIONS

-f, --output-format=FORMAT
    The format of the output file. Can be used to set the output file format if it can’t be autodetected from the output file name. See osmium-file-formats(5) or the libosmium manual for details.

--fsync
    Call fsync after writing the output file to force flushing buffers to disk.

--generator=NAME
    The name and version of the program generating the output file. It will be added to the header of the output file. Default is “osmium/” and the version of osmium.

-o, --output=FILE
    Name of the output file. Default is `-' (STDOUT).

-O, --overwrite
    Allow an existing output file to be overwritten. Normally osmium will refuse to write over an existing file.

--output-header=OPTION=VALUE
    Add output header option. This command line option can be used multiple times for different OPTIONs. See the osmium-output-headers(5) man page for a list of available header options. For some commands you can use the special format “OPTION!” (ie. an exclamation mark after the OPTION and no value set) to set the value to the same as in the input file.

DIAGNOSTICS
osmium merge-changes exits with exit code

0   if everything went alright,

1   if there was an error processing the data, or

2   if there was a problem with the command line arguments.

MEMORY USAGE
osmium merge-changes keeps the contents of all the change files in main memory. This will take roughly 10 times as much memory as the files take on disk in .osc.bz2 format.

EXAMPLES
Merge all changes in changes directory into all.osc.gz:

        osmium merge-changes -o all.osc.gz changes/*.gz

Because osmium merge-changes sorts its input, you can also use it to sort just a single change file:

        osmium merge-changes unsorted.osc.gz -o sorted.osc.gz

SEE ALSO

•   osmium(1), osmium-file-formats(5), osmium-output-headers(5), osmium-merge(1)

•   Osmium website (https://osmcode.org/osmium-tool/)

COPYRIGHT

Copyright (C) 2013-2026 Jochen Topf <jochen@topf.org>.

License GPLv3+: GNU GPL version 3 or later <https://gnu.org/licenses/gpl.html>. This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.

CONTACT

If you have any questions or want to report a bug, please go to https://osmcode.org/contact.html

AUTHORS
Jochen Topf <jochen@topf.org>.